#!/usr/bin/perl

# Set Variables

$guestbookurl = "|/guestbook.html";
$guestbookreal = "|/guestbook.html";
$linereal = "|/line.gif";
$backreal = "|/back.gif";
$guestlog = "|/guestlog.html";
$cgiurl = "|/guestbook.pl";
$date_command = "/bin/date";

$| = 1;
# Set Your Options:
$uselog = 1;            # 1 = Yes; 0 = No
$linkmail = 1;          # 1 = Yes; 0 = No
$separator = 1;         # 1 = <hr>; 0 = <p>
$redirection = 0;       # 1 = Yes; 0 = No
$entry_order = 1;       # 1 = Newest entries added first;
                        # 0 = Newest Entries added last.
$line_breaks = 1;	# 1 = Yes; 0 = No
$allow_html  = 0;
# Done
##############################################################################

$remote_address = $ENV{'REMOTE_ADDR'};
$remote_host = $ENV{'REMOTE_HOST'};

@subnet_number = split (/\./,$remote_address);
$packed_address = pack("C4",@subnet_number);
($remote_host) = gethostbyaddr($packed_address,2);
 
# Get the Date for Entry
$date = `$date_command +"%T %D %Y"`; chop($date);
$shortdate = `$date_command +"%T %D %Y`; chop($shortdate);

# Get the input
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs) {
   ($name, $value) = split(/=/, $pair);

   # Un-Webify plus signs and %-encoding
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value =~ s/<!--(.|\n)*-->//g;

   if ($allow_html != 1) {
      $value =~ s/<([^>]|\n)*>//g;
   }

   $FORM{$name} = $value;
}

# Print the Blank Response Subroutines

&no_comments unless $FORM{'comments'};
&no_name unless $FORM{'realname'};

# Begin the Editing of the Guestbook File

open (FILE,"$guestbookreal") || die "Can't Open $guestbookreal: $!\n";
@LINES=<FILE>;
close(FILE);
$SIZE=@LINES;

# Open Link File to Output
open (GUEST,">$guestbookreal") || die "Can't Open $guestbookreal: $!\n";

for ($i=0;$i<=$SIZE;$i++) {
   $_=$LINES[$i];
   if (/<!--begin-->/) { 
      if ($entry_order eq '1') {
         print GUEST "<!--begin-->\n";
      }
      if ($line_breaks == 1) {
         $FORM{'comments'} =~ s/\cM\n/<br>\n/g;
      }
      if ($FORM{color_text} eq "Blue") {
	 print GUEST "<FONT SIZE=\"3\" COLOR=\"Blue\">\n";
      }	
      if ($FORM{color_text} eq "Red") {
	 print GUEST "<FONT SIZE=\"3\" COLOR=\"Red\">\n";
      }	
      if ($FORM{color_text} eq "Purple") {
	 print GUEST "<FONT SIZE=\"3\" COLOR=\"Purple\">\n";
      }	
      if ($FORM{color_text} eq "Brown") {
	 print GUEST "<FONT SIZE=\"3\" COLOR=\"Brown\">\n";
      }	
      print GUEST "$FORM{'comments'}<br>\n";
      if ($FORM{'url'}) {
         print GUEST "<a href=\"$FORM{'url'}\">$FORM{'realname'}</a>";
      }
      else {
         print GUEST "$FORM{'realname'}";
      }
      if ( $FORM{'username'} ){
         if ($linkmail eq '1') {
            print GUEST " \&lt;<a href=\"mailto:$FORM{'username'}\">";
            print GUEST "$FORM{'username'}</a>\&gt;";
         }
         else {
            print GUEST " &lt;$FORM{'username'}&gt;";
         }
      }
      print GUEST "<br>\n";
      if ($separator eq '1') {
         print GUEST " - $dateAڨӦ$remote_host,IP=$ENV{'REMOTE_HOST'}<br>\n";
	 print GUEST "<CENTER><IMG SRC=\"$linereal\" WIDTH=520 HEIGHT=9 BORDER=0>\n\n<br>";
      }
      else {
         print GUEST " - $date<p>\n\n";
      }

      if ($entry_order eq '0') {
         print GUEST "<!--begin-->\n";
      }
      print GUEST "</FONT>\n";	
   }
   else {
      print GUEST $_;
   }
}

close (GUEST);

# Log The Entry

if ($uselog eq '1') {
   &log('entry');
}

# Print Out Initial Output Location Heading
if ($redirection eq '1') {
   print "Location: http://www.taconet.com.tw/~Ab/guestbook/guestbook.html","\n\n";
}
else { 
   &no_redirection;
}

#######################
# Subroutines

sub no_comments {
   print "Content-type: text/html\n\n";
   print "<html><head><title>лܧa</title></head>\n";
   print "<body BACKGROUND=\"$backreal\"><h1>bdPĳzèSJT</h1>\n<br>";
   print "pGzSܻydUAdON|dUzT!<br>\n";
   print "Ц^<a href=\"$guestbookurl\">dO</a>";
   print "\n</body></html>\n";

   # Log The Error
   if ($uselog eq '1') {
      &log('no_comments');
   }

   exit;
}

sub no_name {
   print "Content-type: text/html\n\n";
   print "<html><head><title>пJzjW</title></head>\n";
   print "<body BACKGROUND=\"$backreal\"><h1>!zѤFdUzjW</h1><br>\n";
   print "Ц^<a href=\"$guestbookurl\">dO</a>";
   print "\n</body></html>\n";

   # Log The Error
   if ($uselog eq '1') {
      &log('no_name');
   }

   exit;
}

# Log the Entry or Error
sub log {
   $log_type = $_[0];
   open (LOG, ">>$guestlog");
   if ($log_type eq 'entry') {
      print LOG "$ENV{'REMOTE_HOST'} - [$shortdate]<br>\n";
   }
   elsif ($log_type eq 'no_name') {
      print LOG "$ENV{'REMOTE_HOST'} - [$shortdate] - ERR: No Name<br>\n";
   }
   elsif ($log_type eq 'no_comments') {
      print LOG "$ENV{'REMOTE_HOST'} - [$shortdate] - ERR: No ";
      print LOG "Comments<br>\n";
   }
}

# Redirection Option
sub no_redirection {
   print "Content-Type: text/html\n\n";
   print "<html><head><title>P±z</title></head>\n";
   print "<body BACKGROUND=\"$backreal\"><CENTER><FONT SIZE=\"4\" FACE=\"з\" COLOR=\"Blue\">\n";
   print "P±zū!</FONT></CENTER><br>\n";
   print "<FONT SIZE=\"3\" FACE=\"з\" COLOR=\"Blue\">\n";
   print "<br><CENTER>zdFHUyѫH<br>\n";
   print "$FORM{'comments'}<br>\n";
   if ($FORM{'url'}) {
      print "<a href=\"$FORM{'url'}\">$FORM{'realname'}</a>";
   }
   else {
      print "$FORM{'realname'}";
   }
   if ( $FORM{'username'} ){
      if ($linkmail eq '1') {
         print " &lt;<a href=\"mailto:$FORM{'username'}\">";
         print "$FORM{'username'}</a>&gt;";
      }
      else {
         print " &lt;$FORM{'username'}&gt;";
      }
   }
   print "<br>\n";
   print " - $date\n";
   # Print End of HTML
   print "<hr>\n";
   print "<a href=\"$guestbookurl\">^dO</a><br>\n";         
   print "- ^dOЫszRELOADAzd~|X{<br>\n";
   print "</FONT>\n";
   print "</CENTER>\n";
   print "</body></html>\n";
   exit;
}

